local beql = LibStub("AceAddon-3.0"):GetAddon("beql");
local L = LibStub("AceLocale-3.0"):GetLocale("beql");

local minwidth = 175;

beql.achievementLineIndex = 1;

-- local framecache
local frames = {};

local leftclicktime
local rightclicktime
--test

function beql:GetCriteria()
	do return end
	beql.cats = {} -- cats
	beql.aids = {} -- Achievements
	beql.cids = {} -- Criteria
	beql.ctypes = {}
	beql.cflags = {}
	local cats = GetCategoryList()
	local Title, ParentCategoryID, Something
	local IDNumber, Name, Points, Completed, Month, Day, Year, Description, Flags, Image, RewardText
	local criteriaString, criteriaType,  quantity, reqQuantity, charName, assetID, quantityString, criteriaID
	local NumAchievements = 0
	local NumCriteria = 0
	local randnumber
	for k,cid in pairs(cats) do
		Title, ParentCategoryID, Something = GetCategoryInfo(cid)
		beql.cats[cid] = {
			Title = Title,  
			ParentCategoryID = ParentCategoryID,
			id = cid,
			number = GetCategoryNumAchievements(cid),
			childs = {},
		}
		
		for i=1, GetCategoryNumAchievements(cid) do
			NumAchievements = NumAchievements + 1
			IDNumber, Name, Points, Completed, Month, Day, Year, Description, Flags, Image, RewardText = GetAchievementInfo(cid, i)
			table.insert(beql.cats[cid].childs, IDNumber)
--[[			beql.aids[IDNumber] = {
--				ID = IDNumber,
				Name = Name,
				Description = Description,
			}--]]
			if GetAchievementNumCriteria(IDNumber) > 0 then
				for i=1, GetAchievementNumCriteria(IDNumber) do
					criteriaString, criteriaType, Completed, quantity, reqQuantity, charName, Flags, assetID, quantityString, criteriaID = GetAchievementCriteriaInfo(IDNumber, i);
--[[					beql.aids[criteriaID] = {
						criteriaString = criteriaString,
						criteriaType = criteriaType,
						Flags = Flags,
						quantityString = quantityString,
					}--]]
					NumCriteria = NumCriteria + 1
					criteriaType = tonumber(criteriaType)
					if not beql.ctypes[criteriaType] then
						beql.ctypes[criteriaType] = {
							AchievementID = IDNumber,
							AchievementTitle = Name,
							criteriaID = criteriaID,
							criteriaString = criteriaString,
							criteriaType = criteriaType,
							Flags = Flags,
							quantityString = quantityString,
						}
					else
						randnumber = random(1 .. 10)
						if randnumber == 5 then
							beql.ctypes[criteriaType] = {
								AchievementID = IDNumber,
								AchievementTitle = Name,
								criteriaID = criteriaID,
								criteriaString = criteriaString,
								criteriaType = criteriaType,
								Flags = Flags,
								quantityString = quantityString,
							}
						end
					end
				end
			end
		end
	end
	table.sort(beql.ctypes)
	print("Achievementscan done with " .. NumCriteria .. " Criteria in " .. NumAchievements .. " Achievements")
end
--  Initial functions
-- creates all needed frames for the Tracker
function beql:InitAchievementTracker()
	
	-- Creates the Position Point of the Tracker
	frames.ATrackerAnchor = CreateFrame("Frame","ATrackerAnchor", UIParent)
	frames.ATrackerAnchor:SetFrameStrata("BACKGROUND")
	frames.ATrackerAnchor:SetFrameLevel(1)
	frames.ATrackerAnchor:SetWidth(1)
	frames.ATrackerAnchor:SetHeight(1)
	frames.ATrackerAnchor:SetMovable(true)
	if beql.db.char.AchievementTracker.posx == 0 and beql.db.char.AchievementTracker.posy == 0 then
		-- on first login, set it to old watchframe position
		beql.ATrackerAnchor:SetPoint("TOPRIGHT", "MinimapCluster", "BOTTOMRIGHT", -93, -13)
		--and save it to char.db
		beql:SavePositionATracker()
	else
		frames.ATrackerAnchor:SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT", beql.db.char.AchievementTracker.posx, beql.db.char.AchievementTracker.posy)
	end
	
	
	-- Creates the main frame
	frames.AchievementWatchFrame = CreateFrame("Frame","AchievementWatchFrame", frames.ATrackerAnchor)
	frames.AchievementWatchFrame:SetFrameStrata("BACKGROUND")
	frames.AchievementWatchFrame:SetHeight(1)
	frames.AchievementWatchFrame:SetWidth(200)
	frames.AchievementWatchFrame:ClearAllPoints()
	frames.AchievementWatchFrame:SetPoint("TOPLEFT",frames.ATrackerAnchor, "TOPLEFT",0,0)
	frames.AchievementWatchFrame:SetMovable(true)
	frames.AchievementWatchFrame:SetScript("OnDragStart",function() 
		frames.ATrackerAnchor.ismoving = true 
		frames.ATrackerAnchor:StartMoving() 
	end)
	frames.AchievementWatchFrame:SetScript("OnDragStop",function() 
		frames.ATrackerAnchor.ismoving = false 
		frames.ATrackerAnchor:StopMovingOrSizing()
		beql:SavePositionATracker()
	end)	
	frames.AchievementWatchFrame.height = 1
	frames.AchievementWatchFrame.width = 200
	
	-- set up mouse events
		frames.AchievementWatchFrame:SetScript("OnUpdate", function() 
--		if not MouseIsOver(AchievementWatchFrame) and beql.db.char.saved.tooltipset then
--			ResetCursor()
--			GameTooltip:FadeOut()
--			beql.db.char.saved.tooltipset = false
--		end
		if MouseIsOver(AchievementWatchFrame) then 
			--beql:TrackerTooltip() 
		end 
	end)
	
	frames.AchievementWatchFrame:SetScript("OnMouseDown", function(self, button)
		-- handel mouse down events, save time of the click
		if button == "LeftButton" then
			leftclicktime = GetTime()
		elseif button == "RightButton" then
			rightclicktime = GetTime()
		end

	--	print(GetTime() .. " " .. self:GetName() .. " " .. button)
	end)
	
	frames.AchievementWatchFrame:SetScript("OnMouseUp", function(self, button)
		if button == "LeftButton" and (GetTime() - leftclicktime) < 1 then
			print("Left Button Clicked")
		elseif button == "RightButton" and (GetTime() - rightclicktime) < 1 then
			print("Left Button Clicked")
		else
			print("no Button clicked, time to long")
		end
	--	print(GetTime() .. " " .. self:GetName() .. " " .. button)
	end)


	
	
	-- Creates Background
	frames.ATrackerBackdrop = CreateFrame("Frame","ATrackerBackdrop", frames.AchievementWatchFrame)
	frames.ATrackerBackdrop:SetFrameStrata("BACKGROUND")
	frames.ATrackerBackdrop:SetFrameLevel(1)
	frames.ATrackerBackdrop:SetMovable(true)
	frames.ATrackerBackdrop:SetAlpha(1)
	frames.ATrackerBackdrop:SetPoint("TOPRIGHT", frames.AchievementWatchFrame, "TOPRIGHT", 5,5)
	frames.ATrackerBackdrop:SetPoint("TOPLEFT", frames.AchievementWatchFrame, "TOPLEFT", -5,5)
	frames.ATrackerBackdrop:SetPoint("BOTTOMRIGHT", frames.AchievementWatchFrame, "BOTTOMRIGHT", 5,-5)
	frames.ATrackerBackdrop:SetPoint("BOTTOMLEFT", frames.AchievementWatchFrame, "BOTTOMLEFT", -5,-5)
	frames.ATrackerBackdrop:SetBackdrop({
		bgFile="Interface\\Tooltips\\UI-Tooltip-Background",
		edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", 
		tile = true, edgeSize = 16, tileSize = 16,
		insets = { left= 4, right = 4, top = 4, bottom = 4 }
		})			
	frames.ATrackerBackdrop:Show()


	-- Creates Title
	frames.ATrackerTitle = CreateFrame("Frame","ATrackerTitle", frames.AchievementWatchFrame)
	frames.ATrackerTitle:ClearAllPoints()
	frames.ATrackerTitle:SetHeight(32)
	frames.ATrackerTitle:SetPoint("BOTTOMLEFT",frames.AchievementWatchFrame, "TOPLEFT",-5,0)
	frames.ATrackerTitle:SetPoint("BOTTOMRIGHT",frames.AchievementWatchFrame, "TOPRIGHT",5,0)
	frames.ATrackerTitle:SetBackdrop({
		bgFile="Interface\\Tooltips\\UI-Tooltip-Background",
		edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", tile = true, edgeSize = 16, tileSize = 16,
		insets = { left= 4, right = 4, top = 4, bottom = 4 }
		})			
	frames.ATrackerTitle:SetFrameStrata("BACKGROUND")
	frames.ATrackerTitle:SetFrameLevel(1)
	frames.ATrackerTitle:SetMovable(true)
	frames.ATrackerTitle:Show()
	frames.ATrackerTitle:SetScript("OnDragStart",function() 
		frames.ATrackerAnchor.ismoving = true 
		frames.ATrackerAnchor:StartMoving() 
	end)
	frames.ATrackerTitle:SetScript("OnDragStop",function() 
		frames.ATrackerAnchor.ismoving = false 
		frames.ATrackerAnchor:StopMovingOrSizing()
		beql:SavePositionATracker()
	end)	

	
	-- Creates Fontstring in Title
	frames.ATrackerTitleText = frames.ATrackerTitle:CreateFontString("ATrackerTitleText","BACKGROUND","GameFontNormal")
	frames.ATrackerTitleText:SetPoint("LEFT",10,1)
	frames.ATrackerTitleText:SetAlpha(1)
	frames.ATrackerTitleText:SetText(L["Achievement Tracker"])


	-- Minimize/Maximize Button
	frames.ATrackerMinimizeButton = CreateFrame("Button","ATrackerMinimizeButton", frames.ATrackerTitle, "UIPanelButtonTemplate")
	frames.ATrackerMinimizeButton:SetNormalTexture("Interface\\AddOns\\beql\\Images\\minimize_up")
	frames.ATrackerMinimizeButton:SetPushedTexture("Interface\\AddOns\\beql\\Images\\minimize_down")
	frames.ATrackerMinimizeButton:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight")
	frames.ATrackerMinimizeButton:SetWidth(18)
	frames.ATrackerMinimizeButton:SetHeight(18)
	frames.ATrackerMinimizeButton:SetFrameLevel(6)
	frames.ATrackerMinimizeButton:Show()
	frames.ATrackerMinimizeButton:ClearAllPoints()
	frames.ATrackerMinimizeButton:SetPoint("TOPRIGHT",frames.ATrackerTitle, "TOPRIGHT", -3,2)
	frames.ATrackerMinimizeButton:SetScript("OnClick", function() 
		if not beql.db.char.AchievementTracker.minimized then 
			beql:minimizeATracker()
			beql.db.char.AchievementTracker.minimized = true
		else
			beql:maximizeATracker()
			beql.db.char.AchievementTracker.minimized = false
			beql:DisplayTrackedAchievements()
		end
	end)
	
	
	-- Drag frame and handle Frame for clicking on tracker
	beql.AchievementWatchLines = CreateFrame("Frame","AchievementWatchLines", ATrackerBackdrop)
	beql.AchievementWatchLines:SetAllPoints(frames.AchievementWatchFrame)
	beql.AchievementWatchLines:SetFrameLevel(5)
	beql.AchievementWatchLines:Hide()
	beql.AchievementWatchLines:RegisterForDrag("LeftButton");
	beql.AchievementWatchLines:SetScript("OnDragStart", function() 
		beql.ATrackerAnchor.ismoving = true 
		beql.ATrackerAnchor:StartMoving() 
	end)
	beql.AchievementWatchLines:SetScript("OnDragStop", function() 
		beql.ATrackerAnchor.ismoving = false 
		beql.ATrackerAnchor:StopMovingOrSizing() 
		beql:SavePositionATracker() 
	end)
end

function beql:ToggleAchievementTrackerStatus()
  beql:GetCriteria()
	if beql.db.profile.atracker.Enable then
		
		--
		-- Hooks
		--
		beql:SecureHook("RemoveTrackedAchievement")
		beql:SecureHook("AddTrackedAchievement")
		beql:RawHook("AchievementButton_ToggleTracking", function(id) return beql:Hooks_AchievementButton_ToggleTracking(id) end, true)
		
		--
		-- Scripts
		--
		-- tracker not loaded, load it 
		if not frames.AchievementWatchFrame then
			beql:InitAchievementTracker()
		end
		
		beql:SetMovableAchievementTracker(beql.db.profile.lockedtracker)
		
		-- try to restore old achievements
		beql:PLAYER_ENTERING_WORLD()
		beql:DisplayTrackedAchievements()
		--
		-- Events
		--
		
		beql:RegisterEvent("ACHIEVEMENT_EARNED");
--		beql:RegisterEvent("PLAYER_ENTERING_WORLD");
		beql:RegisterEvent("TRACKED_ACHIEVEMENT_UPDATE");
		
		--WatchFrame_AddObjectiveHandler(beql.DisplayTrackedAchievements);
		WatchFrame_RemoveObjectiveHandler(WatchFrame_HandleDisplayTrackedAchievements)
		
		if beql.db.char.AchievementTracker.minimized then
			beql:minimizeATracker()
			if beql.db.profile.atracker.showbg then
				if not beql.db.profile.atracker.ownbgcolor then
				-- Set Tooltipcolor as BG color
					frames.ATrackerTitle:SetBackdropBorderColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r,TOOLTIP_DEFAULT_BACKGROUND_COLOR.g,TOOLTIP_DEFAULT_BACKGROUND_COLOR.b)
					frames.ATrackerTitle:SetBackdropColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r,TOOLTIP_DEFAULT_BACKGROUND_COLOR.g,TOOLTIP_DEFAULT_BACKGROUND_COLOR.b)
				else
				-- Set own Colors
					frames.ATrackerTitle:SetBackdropColor(beql.db.profile.atracker.BgColor.r, beql.db.profile.atracker.BgColor.g, beql.db.profile.atracker.BgColor.b, beql.db.profile.atracker.BgColor.a)
					frames.ATrackerTitle:SetBackdropBorderColor(beql.db.profile.atracker.BgCornerColor.r, beql.db.profile.atracker.BgCornerColor.g, beql.db.profile.atracker.BgCornerColor.b, beql.db.profile.atracker.BgCornerColor.a)
				end
			else
				frames.ATrackerTitle:SetBackdropColor(0,0,0,0)
				frames.ATrackerTitle:SetBackdropBorderColor(0,0,0,0)
			end
		end
	else
		if not frames.AchievementWatchFrame then
			-- tracker not loaded, exit 
			return
		end
		
		if beql:IsActive() then
			beql:Unhook("RemoveTrackedAchievement")
			beql:Unhook("AddTrackedAchievement")
			beql:Unhook("AchievementButton_ToggleTracking", function(id) return beql:Hooks_AchievementButton_ToggleTracking(id) end, true)
		end
		
		WatchFrame_AddObjectiveHandler(WatchFrame_HandleDisplayTrackedAchievements);
		--WatchFrame_RemoveObjectiveHandler(beql.DisplayTrackedAchievements)
		
		frames.AchievementWatchFrame:Hide()
		beql:UnregisterEvent("ACHIEVEMENT_EARNED");
		beql:UnregisterEvent("TRACKED_ACHIEVEMENT_UPDATE");
	end

	-- clear Watchframe Display
	WatchFrame_ClearDisplay();
	WatchFrame_Update(WatchFrame);
	
end

--
-- Hooks
--

function beql:Hooks_AchievementButton_ToggleTracking(id)

	if beql:IsAchievementTracked(id) then
		RemoveTrackedAchievement(id)
		AchievementFrameAchievements_ForceUpdate();
		return
	end
	
	if GetNumTrackedAchievements() == WATCHFRAME_MAXACHIEVEMENTS then
		-- wh have reached the limit, exit
		UIErrorsFrame:AddMessage(format(ACHIEVEMENT_WATCH_TOO_MANY, WATCHFRAME_MAXACHIEVEMENTS), 1.0, 0.1, 0.1, 1.0);
		return;
	end
	
	-- check if we can add it
	local Achievements = {}
	local AchievementIDs = {GetTrackedAchievements()};
	table.insert(AchievementIDs, id)
	local numTrackedAchievements = #AchievementIDs
	
	-- beql.db.profile.atracker.ManageLines 
	-- beql.db.profile.atracker.NumLines
	
	local usedlines = 0
	local achievementusedlines
	local maxlines = 0
	local numCriteria
	
	for _, achievementID in pairs(AchievementIDs) do
		Achievements[achievementID] = {}
		Achievements[achievementID].criteria = {}
		numCriteria = GetAchievementNumCriteria(achievementID)
		usedlines = usedlines + 1 -- title
		achievementusedlines = 0
		for j=1, numCriteria, 1 do
			if not select(3, GetAchievementCriteriaInfo(achievementID, j)) then
				achievementusedlines = achievementusedlines + 1
				table.insert(Achievements[achievementID].criteria, j)
			end
			if numCriteria == 1 and ( bit.band(select(7, GetAchievementCriteriaInfo(achievementID, j)), ACHIEVEMENT_CRITERIA_PROGRESS_BAR) == ACHIEVEMENT_CRITERIA_PROGRESS_BAR ) then
				print("Achievemantid: " .. achievementID .. " has a progrss bar")
				achievementusedlines = achievementusedlines + 1
			end
		end
		
		usedlines = usedlines + achievementusedlines
		
		if numCriteria == 0 then
			-- Achievement with no objective, we need 1 line for discription
			usedlines = usedlines + 1
		end
		if achievementusedlines > maxlines then
			maxlines = achievementusedlines
		end
		Achievements[achievementID].NumLines = achievementusedlines;
	end
	
	if not beql.db.profile.atracker.ManageLines and usedlines > 60 then
		-- will use more lines the avalible, don't add item
		UIErrorsFrame:AddMessage(OBJECTIVES_WATCH_TOO_MANY, 1.0, 0.1, 0.1, 1.0);
		return 
	end
	
	
	print(usedlines)


	AddTrackedAchievement(id)
	AchievementFrameAchievements_ForceUpdate();
	return true

end

function beql:AddTrackedAchievement(id)
	
	-- clean up old data
	for k,v in next, beql.db.char.AchievementTracker.Achievements do
		beql.db.char.AchievementTracker.Achievements[k] = nil
	end
	
	-- get new data
	beql.db.char.AchievementTracker.Achievements = { GetTrackedAchievements() }
end

function beql:RemoveTrackedAchievement(id)
	
	-- clean up old data
	for k,v in next, beql.db.char.AchievementTracker.Achievements do
		beql.db.char.AchievementTracker.Achievements[k] = nil
	end
	
	-- get new data
	beql.db.char.AchievementTracker.Achievements = { GetTrackedAchievements() }
end

--
--  EVENTS
--

function beql:PLAYER_ENTERING_WORLD ()
	
	-- this is needed, bacause add/remove a achievement will overwrite beql.db.char.AchievementTracker.Achievements
	local AchievementIDs = {unpack(beql.db.char.AchievementTracker.Achievements)}
	
	-- restore last tracked achievements
	if beql.db.profile.atracker.savelast then
		for k,id in pairs(AchievementIDs) do
			if not select(4, GetAchievementInfo(id)) then
				AddTrackedAchievement(id)
			end
		end
	end

	beql:UnregisterEvent("PLAYER_ENTERING_WORLD")
end 

function beql:TRACKED_ACHIEVEMENT_UPDATE()

	if not beql.db.profile.atracker.Enable then
		return;
	end
	
	beql:DisplayTrackedAchievements()
end

-- Remove tracked achievement
function beql:ACHIEVEMENT_EARNED ()
	local lastfinished, _ , _ , _ , _ = GetLatestCompletedAchievements()
	if GetTrackedAchievements() == lastfinished then
		SetTrackedAchievement(0)
	end
end


-- Addon funktions

function beql:IsAchievementTracked(id)
	local Achievements = { GetTrackedAchievements() }
	
	for k, aID in pairs(Achievements) do
		if id == aID then
			return true
		end
	end
	return false
end

-- Save Position in Profile
function beql:SavePositionATracker()
	local Right = ATrackerAnchor:GetRight()
	local Top = ATrackerAnchor:GetTop()
	if Right and Top then
		beql.db.char.AchievementTracker.posx = Right
		beql.db.char.AchievementTracker.posy = Top
	end
	frames.ATrackerAnchor:SetPoint("TOPRIGHT", "UIParent", "BOTTOMLEFT", beql.db.char.AchievementTracker.posx, beql.db.char.AchievementTracker.posy)
end

function beql:moveableATracker(newval)
	beql.db.profile.atracker.Locked = newval
	if newval then
			beql.ATrackerDrag:SetMovable(false)
			beql.ATrackerDrag:EnableMouse(false)
	else
			beql.ATrackerDrag:EnableMouse(true)
			beql.ATrackerDrag:SetMovable(true)
	end

end

function beql:minimizeATracker()
	frames.ATrackerMinimizeButton:SetNormalTexture("Interface\\AddOns\\beql\\Images\\restore_up")
	frames.ATrackerMinimizeButton:SetPushedTexture("Interface\\AddOns\\beql\\Images\\restore_down")	
	
	frames.AchievementWatchFrame:SetHeight(1)
	frames.AchievementWatchFrame:SetWidth(frames.ATrackerTitleText:GetWidth()+32)
	frames.ATrackerBackdrop:Hide()
	
	
end

function beql:maximizeATracker()

	frames.ATrackerMinimizeButton:SetNormalTexture("Interface\\AddOns\\beql\\Images\\minimize_up")
	frames.ATrackerMinimizeButton:SetPushedTexture("Interface\\AddOns\\beql\\Images\\minimize_down")	

	frames.ATrackerBackdrop:Show()
	
	-- todo
	frames.AchievementWatchFrame:SetHeight(frames.AchievementWatchFrame.height)
	frames.AchievementWatchFrame:SetWidth(frames.AchievementWatchFrame.width)
	--frames.AchievementWatchFrame.width = frames.AchievementWatchFrame:GetWidth()
	--frames.AchievementWatchFrame.height = frames.AchievementWatchFrame:GetHeight()

end

function beql:ATracker_Update()



-- Headline
	--[[
	beql.ATrackerDrag:ClearAllPoints()
	if ATrackerTitle:IsShown() and beql.db.profile.atracker.headline == false then
		ATrackerTitle:Hide()
		beql.ATrackerDrag:SetPoint("TOPLEFT",ATracker, "TOPLEFT",0,0)
		beql.ATrackerDrag:SetPoint("TOPRIGHT",ATracker, "TOPRIGHT",0,0)
	else
		ATrackerTitle:Show()
		beql.ATrackerDrag:SetPoint("TOPLEFT",ATrackerTitle, "TOPLEFT",0,0)
		beql.ATrackerDrag:SetPoint("TOPRIGHT",ATrackerTitle, "TOPRIGHT",0,0)
	end
	beql.ATrackerDrag:SetPoint("BOTTOMLEFT",ATracker, "BOTTOMLEFT",0,0)
	beql.ATrackerDrag:SetPoint("BOTTOMRIGHT",ATracker, "BOTTOMRIGHT",0,0)
	--]]

-- Alpha
	frames.ATrackerBackdrop:SetAlpha(beql.db.profile.atracker.alpha)
	frames.ATrackerTitle:SetAlpha(beql.db.profile.atracker.alpha)

-- Scale
	frames.AchievementWatchFrame:SetScale(beql.db.profile.atracker.scale)

-- Colorhandling
	if beql.db.profile.atracker.showbg then
		if not beql.db.profile.atracker.ownbgcolor then
		-- Set Tooltipcolor as BG color
			frames.ATrackerTitle:SetBackdropBorderColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r,TOOLTIP_DEFAULT_BACKGROUND_COLOR.g,TOOLTIP_DEFAULT_BACKGROUND_COLOR.b)
			frames.ATrackerTitle:SetBackdropColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r,TOOLTIP_DEFAULT_BACKGROUND_COLOR.g,TOOLTIP_DEFAULT_BACKGROUND_COLOR.b)
			frames.ATrackerBackdrop:SetBackdropBorderColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r,TOOLTIP_DEFAULT_BACKGROUND_COLOR.g,TOOLTIP_DEFAULT_BACKGROUND_COLOR.b)
			frames.ATrackerBackdrop:SetBackdropColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r,TOOLTIP_DEFAULT_BACKGROUND_COLOR.g,TOOLTIP_DEFAULT_BACKGROUND_COLOR.b)
		else
		-- Set own Colors
			frames.ATrackerTitle:SetBackdropColor(beql.db.profile.atracker.BgColor.r, beql.db.profile.atracker.BgColor.g, beql.db.profile.atracker.BgColor.b, beql.db.profile.atracker.BgColor.a)
			frames.ATrackerTitle:SetBackdropBorderColor(beql.db.profile.atracker.BgCornerColor.r, beql.db.profile.atracker.BgCornerColor.g, beql.db.profile.atracker.BgCornerColor.b, beql.db.profile.atracker.BgCornerColor.a)
			frames.ATrackerBackdrop:SetBackdropColor(beql.db.profile.atracker.BgColor.r, beql.db.profile.atracker.BgColor.g, beql.db.profile.atracker.BgColor.b, beql.db.profile.atracker.BgColor.a)
			frames.ATrackerBackdrop:SetBackdropBorderColor(beql.db.profile.atracker.BgCornerColor.r, beql.db.profile.atracker.BgCornerColor.g, beql.db.profile.atracker.BgCornerColor.b, beql.db.profile.atracker.BgCornerColor.a)
		end
	else
		frames.ATrackerTitle:SetBackdropColor(0,0,0,0)
		frames.ATrackerTitle:SetBackdropBorderColor(0,0,0,0)
		frames.ATrackerBackdrop:SetBackdropColor(0,0,0,0)
		frames.ATrackerBackdrop:SetBackdropBorderColor(0,0,0,0)
	end

end

function beql:GetAchievementLine ()
	
	local button
	
	local line = beql.FrameCache.AchievementLines[beql.FrameCache.AchievementLineIndex];
	if ( not line ) then
		beql.FrameCache.AchievementLines[beql.FrameCache.AchievementLineIndex] = beql.FrameCache.Lines:GetFrame();
		line = beql.FrameCache.AchievementLines[beql.FrameCache.AchievementLineIndex];
	end
	
	line:Reset();
	
	-- reset icon
	line.iconframe:Hide()
	
	line:SetParent(frames.ATrackerBackdrop)
	beql.FrameCache.AchievementLineIndex = beql.FrameCache.AchievementLineIndex + 1;
	return line;
end

function beql:ReleaseUnusedAchievementLines ()
	local line
	for i = beql.FrameCache.AchievementLineIndex, #beql.FrameCache.AchievementLines do
		line = beql.FrameCache.AchievementLines[i];
		line:Hide();
		line.frameCache:ReleaseFrame(line);
		beql.FrameCache.AchievementLines[i] = nil;
	end
	
	beql.FrameCache.AchievementLineIndex = 1
end

function beql:GetAchievementLinkButton()
	local button = beql.FrameCache.AchievementLinkButtons[beql.FrameCache.AchievementLinkButtonIndex]
	if ( not button ) then
		beql.FrameCache.AchievementLinkButtons[beql.FrameCache.AchievementLinkButtonIndex] = beql.FrameCache.Buttons:GetFrame();
		button = beql.FrameCache.AchievementLinkButtons[beql.FrameCache.AchievementLinkButtonIndex];
	end

	button:SetParent(frames.ATrackerBackdrop)
	button:SetFrameLevel(frames.ATrackerBackdrop:GetFrameLevel()+2)
	button:SetScript("OnDragStart",function() 
		frames.ATrackerAnchor.ismoving = true 
		frames.ATrackerAnchor:StartMoving() 
	end)
	button:SetScript("OnDragStop",function() 
		frames.ATrackerAnchor.ismoving = false 
		frames.ATrackerAnchor:StopMovingOrSizing()
		beql:SavePositionATracker()
	end)	
	
	--button:SetFrameStrata("MEDIUM")
	beql.FrameCache.AchievementLinkButtonIndex = beql.FrameCache.AchievementLinkButtonIndex + 1;
	return button;
end

function beql:ReleaseUnusedAchievementButtons ()
	local button
	for i = beql.FrameCache.AchievementLinkButtonIndex, #beql.FrameCache.AchievementLinkButtons do
		button = beql.FrameCache.AchievementLinkButtons[i];
		button:Hide();
		button.frameCache:ReleaseFrame(button);
		beql.FrameCache.AchievementLinkButtons[i] = nil;
	end
	
	beql.FrameCache.AchievementLinkButtonIndex = 1;
end

function beql:DisplayTrackedAchievements(lineFrame, initialOffset, maxHeight, frameWidth)
	if beql.db.char.AchievementTracker.minimized then
		-- tracker minimized, exit
		return
	end
	
	
	local _; -- Doing this here thanks to IBLJerry!
	local self = WatchFrame;
	local numTrackedAchievements = select("#", GetTrackedAchievements());
	
	--HACK:
	lineFrame = frames.AchievementWatchFrame
	initialOffset = 0
	local WATCHFRAME_CRITERIA_PER_ACHIEVEMENT = WATCHFRAME_CRITERIA_PER_ACHIEVEMENT + 1; -- + 1 iss a dummy, because we handle the latst line in an other way
	Achievements = {}
	local extralines = 0;
	
	
	local lineCache = WatchFrame.lineCache;
	local maxWidth = 0;
	local heightUsed = 0;
	local heightNeeded = 0;
	
	local achievementID;
	local achievementName, completed, description, icon;
	
	local line;
	local achievementTitle;
	local previousLine;
	local nextXOffset = 0;
	local linkButton;
		
	local numCriteria, criteriaDisplayed;
	local criteriaString, criteriaType, criteriaCompleted, quantity, totalQuantity, name, flags, assetID, quantityString, criteriaID, achievementCategory;
	
	-- get used lines per achievement
	local maxlines = 0
	local usedlines = 0
	local achievementusedlines
	for i = 1 , numTrackedAchievements, 1 do
		achievementID = select(i, GetTrackedAchievements());
		Achievements[achievementID] = {}
		Achievements[achievementID].criteria = {}
		numCriteria = GetAchievementNumCriteria(achievementID)
		usedlines = usedlines + 1 -- title
		achievementusedlines = 0
		for j=1, numCriteria, 1 do
			if not select(3, GetAchievementCriteriaInfo(achievementID, j)) then
				usedlines = usedlines + 1
				achievementusedlines = achievementusedlines + 1
				table.insert(Achievements[achievementID].criteria, j)
			end
			if numCriteria == 1 and ( bit.band(select(7, GetAchievementCriteriaInfo(achievementID, j)), ACHIEVEMENT_CRITERIA_PROGRESS_BAR) == ACHIEVEMENT_CRITERIA_PROGRESS_BAR ) then
				extralines = extralines + 1
			end
		end
		
		if numCriteria == 0 then
			-- Achievement with no objective, we need 1 line for discription
			usedlines = usedlines + 1
		end
		if achievementusedlines > maxlines then
			maxlines = achievementusedlines
		end
		Achievements[achievementID].NumLines = achievementusedlines;
	end
	
	-- calc optimal lines per achievement
	if beql.db.profile.atracker.ManageLines and type(beql.db.profile.atracker.NumLines) == 'number' then
		WATCHFRAME_CRITERIA_PER_ACHIEVEMENT = 0
		for i = maxlines, 1, -1 do
			usedlines = 0
			for k,v in pairs(Achievements) do
				if v.NumLines > i then
					usedlines = usedlines + i
				else
					usedlines = usedlines + v.NumLines
				end
				
				if v.NumLines == 0 then
					-- Achievement with no objective, we need 1 line for discription
					usedlines = usedlines + 1
				end
			end
			
			if (usedlines + numTrackedAchievements) <= beql.db.profile.atracker.NumLines then
				beql:debugprint("break at " .. i .. " Line(s) per Achievement, " .. (usedlines + numTrackedAchievements) .. " Lines total, " .. (beql.db.profile.atracker.NumLines - (usedlines + numTrackedAchievements)).. " Lines in reserve")
				extralines = beql.db.profile.atracker.NumLines - (usedlines + numTrackedAchievements)
				WATCHFRAME_CRITERIA_PER_ACHIEVEMENT = i
				break
			end
		end
	end

	local displayOnlyArena = (not WatchFrame:IsUserPlaced()) and ArenaEnemyFrames and ArenaEnemyFrames:IsShown();
	for i = 1, numTrackedAchievements do
		achievementID = select(i, GetTrackedAchievements());
		achievementCategory = GetAchievementCategory(achievementID);
		if ( (not displayOnlyArena) or achievementCategory == WATCHFRAME_ACHIEVEMENT_ARENA_CATEGORY ) then
			_, achievementName, _, completed, _, _, _, description, _, icon = GetAchievementInfo(achievementID);
			
			--
			-- Title
			--
			
			line = beql:GetAchievementLine();
			achievementTitle = line;
			line.text:SetText(achievementName);
			if ( completed ) then
				line.text:SetTextColor(NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
			else
				line.text:SetTextColor(0.75, 0.61, 0);
			end
			line:Show()
			local lineWidth = line.text:GetStringWidth() + WATCHFRAME_ICONXOFFSET
			maxWidth = max(maxWidth, lineWidth)
			if ( previousLine ) then -- If this isn't the first displayed title, our position is relative to the last displayed line.
				local yOffset = 0;
				if ( previousLine.statusBar:IsShown() ) then
					yOffset = -5
				end
				
				line:SetPoint("TOPRIGHT", previousLine, "BOTTOMRIGHT", 0, yOffset - WATCHFRAME_QUEST_OFFSET);
				line:SetPoint("TOPLEFT", previousLine, "BOTTOMLEFT", nextXOffset, yOffset - WATCHFRAME_QUEST_OFFSET);
			else
				line:SetPoint("TOPRIGHT", lineFrame, "TOPRIGHT", 0, initialOffset);
				line:SetPoint("TOPLEFT", lineFrame, "TOPLEFT", 0, initialOffset);
			end
			
			--
			-- LinkButton
			--
			if icon then
				line.icon:SetTexture(icon)
				line.icon:ClearAllPoints()
				line.icon:SetPoint("LEFT", line, "LEFT", 3, -1)
				line.text:SetPoint("TOPLEFT", line, "TOPLEFT",22,0)
				
				-- calc border offset
				local offset = line.icon:GetHeight()/3.2
				
				line.iconborder:ClearAllPoints()
--				line.iconborder:SetAllPoints(line.iconframe)
				line.iconborder:SetPoint("TOPLEFT", line.icon, "TOPLEFT", -offset, offset)
				line.iconborder:SetPoint("TOPRIGHT", line.icon, "TOPRIGHT", offset, offset)
				line.iconborder:SetPoint("BOTTOMLEFT", line.icon, "BOTTOMLEFT", -offset, -offset)
				line.iconborder:SetPoint("BOTTOMLEFT", line.icon, "BOTTOMLEFT", offset, -offset)
				--line.iconborder:Hide()
				--line.iconborder:SetHeight((line.icon:GetHeight()/4)*6.5)
				--line.iconborder:SetWidth((line.icon:GetHeight()/4)*6.5)
				line.iconframe:Show()
			end
			if 1 == 2 then
				linkButton = beql:GetAchievementLinkButton(frames.AchievementWatchFrame);
				linkButton:SetPoint("TOPLEFT", line.text, "TOPLEFT",-WATCHFRAME_ICONXOFFSET+4,0);
				--linkButton:SetPoint("BOTTOMLEFT", line.text);
				linkButton:SetWidth(16);
				linkButton:SetHeight(16);
				linkButton:SetNormalTexture(icon)
				linkButton.type = "ACHIEVEMENT"
				linkButton.index = achievementID;
				linkButton:Show();
			end
			
--[[				linkButton = beql:GetAchievementLinkButton(frames.AchievementWatchFrame);
				if icon then
					linkButton:SetPoint("TOPLEFT", line.icon);
				else
					linkButton:SetPoint("TOPLEFT", line.text);
				end
				linkButton:SetPoint("BOTTOMLEFT", line.text);
				linkButton:SetWidth(lineWidth + WATCHFRAME_ICONXOFFSET);
				linkButton.type = "ACHIEVEMENT"
				linkButton.index = achievementID;
				linkButton:Show();--]]
				
--				print("get Button" .. linkButton:GetName())
--				beql:printpoints(linkButton)
--				print(linkButton:GetParent():GetName())

			nextXOffset =  0;
			previousLine = line;
			
			--
			-- Details (Criteria)
			--
			
			numCriteria = Achievements[achievementID].NumLines;
			if numCriteria > WATCHFRAME_CRITERIA_PER_ACHIEVEMENT then
				if extralines > 0 then
					-- we have empty lines over, so we use them 
					numCriteria = WATCHFRAME_CRITERIA_PER_ACHIEVEMENT + 1
					extralines = extralines - 1
				else
					numCriteria = WATCHFRAME_CRITERIA_PER_ACHIEVEMENT
				end
			end
			
			if ( numCriteria > 0 ) then
				
				--
				-- Achivements with Criteria
				--
				criteriaDisplayed = 0;
				for j = 1, numCriteria do
					criteriaString, criteriaType, criteriaCompleted, quantity, totalQuantity, name, flags, assetID, quantityString, criteriaID = GetAchievementCriteriaInfo(achievementID, Achievements[achievementID].criteria[j]);
					if ( j == numCriteria and (numCriteria < Achievements[achievementID].NumLines) ) then
						-- We ran out of space to display incomplete criteria >_<
						line = beql:GetAchievementLine();
						line.text:SetText(" - ");
						local dashWidth = line.text:GetStringWidth();
-- great idea, but why we must move the whole line if we can only need to move the font string?
--						nextXOffset = nextXOffset + dashWidth -- Offset as if there were a dash
						line.text:SetPoint("TOPLEFT", line, "TOPLEFT", dashWidth, 0)
						line.text:SetText("...");
						line.text:SetTextColor(0.8, 0.8, 0.8);
						line:SetPoint("TOPLEFT", previousLine, "BOTTOMLEFT", nextXOffset , 3);
						line:SetPoint("TOPRIGHT", previousLine, "BOTTOMRIGHT", 0, 3);
						line:Show();
						maxWidth = max(maxWidth, line.text:GetStringWidth()); -- I can't imagine this happening anytime soon really
						criteriaDisplayed = criteriaDisplayed + 1;
						previousLine = line;
						--nextXOffset = -dashWidth;
					else
						
						--
						-- Timed Criteria
						--
						if ( WATCHFRAME_TIMEDCRITERIA[criteriaID] ) then
							local timedCriteria = WATCHFRAME_TIMEDCRITERIA[criteriaID]
							line = beql:GetAchievementLine();
							line.criteriaID = criteriaID;
							line.duration = timedCriteria.duration;
							line.startTime = timedCriteria.startTime;
							
							local yOffset = WATCHFRAMELINES_FONTSPACING;
							if ( previousLine.statusBar:IsShown() ) then
								yOffset = yOffset - 5;
							end
							line:SetPoint("TOPRIGHT", previousLine, "BOTTOMRIGHT", 0, yOffset);
							line:SetPoint("TOPLEFT", previousLine, "BOTTOMLEFT", nextXOffset, yOffset);
							line:Show()
							criteriaDisplayed = criteriaDisplayed + 1;
							previousLine = line;
							nextXOffset = 0;
							WatchFrameLines_AddUpdateFunction(WatchFrame_UpdateTimedAchievements);
						end
						
						--
						-- Criteria with Statusbar
						--
						if ( bit.band(flags, ACHIEVEMENT_CRITERIA_PROGRESS_BAR) == ACHIEVEMENT_CRITERIA_PROGRESS_BAR ) then
							line = beql:GetAchievementLine();
							line.statusBar:Show();
							line.statusBar:GetStatusBarTexture():SetVertexColor(0, 0.6, 0, 1);
							line.statusBar:SetMinMaxValues(0, totalQuantity);
							line.statusBar:SetValue(quantity);
							line.statusBar.text:SetText(quantityString);
							
							local yOffset = -5;
							if ( previousLine.statusBar:IsShown() ) then
								yOffset = -10;
							end
							
							line:SetPoint("TOPRIGHT", previousLine, "BOTTOMRIGHT", 0, yOffset);
							line:SetPoint("TOPLEFT", previousLine, "BOTTOMLEFT", nextXOffset, yOffset);					
							line:Show();
							maxWidth = max(maxWidth, 200);
							criteriaDisplayed = criteriaDisplayed + 2;
							nextXOffset = 0;
							previousLine = line;
						else
							
							--
							-- Normal Achievements with objectives
							--
							line = beql:GetAchievementLine();
							line.text:SetText(" - " .. criteriaString);
							line.text:SetTextColor(0.8, 0.8, 0.8);
							local yOffset = WATCHFRAMELINES_FONTSPACING;
							if ( previousLine.statusBar:IsShown() ) then
								yOffset = yOffset - 5;
							end
							
							if criteriaType == 8 then
								line.iconframe:Show()
								line.icon:SetTexture(select(10, GetAchievementInfo(assetID)))
								line.icon:ClearAllPoints()
								line.icon:SetPoint("TOPLEFT", line.text,"TOPLEFT",line.text:GetStringWidth()+3,-2)
								line.icon:SetHeight(12)
								line.icon:SetWidth(12)
								--line.iconborder:Show()
								line.iconborder:SetHeight((line.icon:GetHeight()/4)*6.5)
								line.iconborder:SetWidth((line.icon:GetHeight()/4)*6.5)
								
--								linkButton = beql:GetAchievementLinkButton(frames.AchievementWatchFrame);
--								linkButton:SetAllPoints(line.icon)
--								linkButton.type = "ACHIEVEMENT"
--								linkButton.index = assetID;
--								linkButton:Show();
								maxWidth = max(maxWidth, line.text:GetStringWidth() + 22);

							end
							line:SetPoint("TOPRIGHT", previousLine, "BOTTOMRIGHT", 0, yOffset);
							line:SetPoint("TOPLEFT", previousLine, "BOTTOMLEFT", nextXOffset, yOffset);
							line:Show();
							maxWidth = max(maxWidth, line.text:GetStringWidth());
							criteriaDisplayed = criteriaDisplayed + 1;
							nextXOffset = 0;
							previousLine = line;
						end
					end
				end
			else
			
				--
				-- Achievement with no criteria, display Discription
				--
				local dash = beql:GetAchievementLine();
				dash.text:SetText(" - ");
				dash.text:SetTextColor(0.8, 0.8, 0.8);
				local yOffset = WATCHFRAMELINES_FONTSPACING;
				if ( previousLine.statusBar:IsShown() ) then
					yOffset = yOffset - 5;
				end
				
				local dashWidth = dash.text:GetStringWidth();
				
				dash:SetWidth(dashWidth);
				dash:SetPoint("TOPLEFT", previousLine, "BOTTOMLEFT", nextXOffset, yOffset);
				dash:Show();
				
				line = beql:GetAchievementLine();
				line.text:SetText(description);
				line.text:SetTextColor(0.8, 0.8, 0.8);
				
				local stringWidth = line.text:GetStringWidth();
				local desiredWidth = math.ceil(stringWidth + dashWidth); -- This is how long we want the line to be with no wrapping
				
				if ( desiredWidth > maxWidth ) then
					maxWidth = min(desiredWidth, MAX_LONG_CRITERIA_WIDTH);
				end
				
				local linesNeeded = math.ceil(stringWidth / (maxWidth - dashWidth));
				
				line:SetPoint("TOPLEFT", dash, "TOPRIGHT");
				line:SetPoint("TOPRIGHT", previousLine, "TOPRIGHT", 0, yOffset);
				line:SetHeight((WATCHFRAME_LINEHEIGHT - WATCHFRAMELINES_FONTSPACING) + (WATCHFRAMELINES_FONTHEIGHT * (linesNeeded - 1)));
				line:Show();
				
				nextXOffset = -dashWidth;
				previousLine = line;	
				
				for criteriaID, timedCriteria in next, WATCHFRAME_TIMEDCRITERIA do
					if ( timedCriteria.achievementID == achievementID ) then
						line = beql:GetAchievementLine();
						line.criteriaID = criteriaID;
						line.duration = timedCriteria.duration;
						line.startTime = timedCriteria.startTime;
						
						local yOffset = WATCHFRAMELINES_FONTSPACING;
						if ( previousLine.statusBar:IsShown() ) then
							yOffset = yOffset - 5;
						end
						line:SetPoint("TOPRIGHT", previousLine, "BOTTOMRIGHT", 0, yOffset);
						line:SetPoint("TOPLEFT", previousLine, "BOTTOMLEFT", nextXOffset, yOffset);
						line:Show()
						previousLine = line;
						nextXOffset = 0;
						WatchFrameLines_AddUpdateFunction(WatchFrame_UpdateTimedAchievements);
					end
				end
			end
		end
	end
	
	if beql.FrameCache.AchievementLineIndex > 1 then
		frames.AchievementWatchFrame:Show()
	else
		frames.AchievementWatchFrame:Hide()
	end
		
	beql:ReleaseUnusedAchievementLines();
	beql:ReleaseUnusedAchievementButtons();
	
	if not frames.AchievementWatchFrame:IsVisible() then
		-- Frame is hidden, exit
		return
	end
	
	-- width and height
	frames.AchievementWatchFrame:SetWidth(maxWidth)
	frames.AchievementWatchFrame:SetHeight(frames.AchievementWatchFrame:GetTop() - line:GetBottom())
	
	frames.AchievementWatchFrame.width = frames.AchievementWatchFrame:GetWidth()
	frames.AchievementWatchFrame.height = frames.AchievementWatchFrame:GetHeight()
	
	-- titlebar
	if beql.db.profile.atracker.headline then
		frames.ATrackerTitle:Show()
		frames.ATrackerTitleText:SetText(L["Achievement Tracker"] .. " ("..numTrackedAchievements .. "/" .. WATCHFRAME_MAXACHIEVEMENTS .. ")")
	else
		frames.ATrackerTitle:Hide()
	end
	
-- Alpha
	frames.ATrackerBackdrop:SetAlpha(beql.db.profile.atracker.alpha)
	frames.ATrackerTitle:SetAlpha(beql.db.profile.atracker.alpha)

-- Scale
	frames.AchievementWatchFrame:SetScale(beql.db.profile.atracker.scale)

-- Colorhandling
	if beql.db.profile.atracker.showbg then
		if not beql.db.profile.atracker.ownbgcolor then
		-- Set Tooltipcolor as BG color
			frames.ATrackerTitle:SetBackdropBorderColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r,TOOLTIP_DEFAULT_BACKGROUND_COLOR.g,TOOLTIP_DEFAULT_BACKGROUND_COLOR.b)
			frames.ATrackerTitle:SetBackdropColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r,TOOLTIP_DEFAULT_BACKGROUND_COLOR.g,TOOLTIP_DEFAULT_BACKGROUND_COLOR.b)
			frames.ATrackerBackdrop:SetBackdropBorderColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r,TOOLTIP_DEFAULT_BACKGROUND_COLOR.g,TOOLTIP_DEFAULT_BACKGROUND_COLOR.b)
			frames.ATrackerBackdrop:SetBackdropColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r,TOOLTIP_DEFAULT_BACKGROUND_COLOR.g,TOOLTIP_DEFAULT_BACKGROUND_COLOR.b)
		else
		-- Set own Colors
			frames.ATrackerTitle:SetBackdropColor(beql.db.profile.atracker.BgColor.r, beql.db.profile.atracker.BgColor.g, beql.db.profile.atracker.BgColor.b, beql.db.profile.atracker.BgColor.a)
			frames.ATrackerTitle:SetBackdropBorderColor(beql.db.profile.atracker.BgCornerColor.r, beql.db.profile.atracker.BgCornerColor.g, beql.db.profile.atracker.BgCornerColor.b, beql.db.profile.atracker.BgCornerColor.a)
			frames.ATrackerBackdrop:SetBackdropColor(beql.db.profile.atracker.BgColor.r, beql.db.profile.atracker.BgColor.g, beql.db.profile.atracker.BgColor.b, beql.db.profile.atracker.BgColor.a)
			frames.ATrackerBackdrop:SetBackdropBorderColor(beql.db.profile.atracker.BgCornerColor.r, beql.db.profile.atracker.BgCornerColor.g, beql.db.profile.atracker.BgCornerColor.b, beql.db.profile.atracker.BgCornerColor.a)
		end
	else
		frames.ATrackerTitle:SetBackdropColor(0,0,0,0)
		frames.ATrackerTitle:SetBackdropBorderColor(0,0,0,0)
		frames.ATrackerBackdrop:SetBackdropColor(0,0,0,0)
		frames.ATrackerBackdrop:SetBackdropBorderColor(0,0,0,0)
	end

	
	return 0,0
end

--- EOF ---